"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _component = _interopRequireDefault(require("../component"));

var _query = require("../compiler/query");

var _propFiller = _interopRequireDefault(require("../compiler/prop-filler"));

var _componentFillerProps = _interopRequireDefault(require("../component/component-filler-props"));

var _registrar = _interopRequireDefault(require("../compiler/registrar"));

var _globals = _interopRequireDefault(require("../globals"));

var _access = _interopRequireDefault(require("../access"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Action = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Action, _Component);

  var _super = _createSuper(Action);

  function Action() {
    var _this;

    (0, _classCallCheck2.default)(this, Action);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "className", 'Action');
    return _this;
  }

  (0, _createClass2.default)(Action, [{
    key: "create",
    value: function create(props) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(Action.prototype), "create", this).call(this, props); // For mocking

      this._registrar = _registrar.default;
      this._globals = _globals.default;
      this._access = _access.default;
      this._componentFillerProps = new _componentFillerProps.default();
      this._fillerProps = null;
      this.set({
        schema: {
          component: 'Form',
          fields: [{
            name: 'if',
            component: 'WhereField'
          }, {
            name: 'actions',
            component: 'Field'
          }, {
            name: 'else',
            component: 'Field'
          }, {
            name: 'layer',
            component: 'TextField'
          }, {
            name: 'detached',
            component: 'BooleanField'
          }]
        }
      });
    } // Abstract method
    // async act(/* props */) {}

  }, {
    key: "_fill",
    value: function _fill(prop, preventQuery, customizer) {
      var propFiller = new _propFiller.default(this._fillerProps); // Fill with props from component first so that we define default values in the component like
      // {{fields.to.value}} that are then filled via the second fill.

      prop = propFiller.fill(prop, preventQuery, customizer);
      prop = propFiller.fill(prop, preventQuery); // Yes, this duplicate is needed!

      return prop;
    }
  }, {
    key: "_getFilled",
    value: function _getFilled(names, preventQuery, customizer) {
      var prop = (0, _get2.default)((0, _getPrototypeOf2.default)(Action.prototype), "get", this).call(this, names); // When names are undefined, we need to prevent props being considered a query as a nested "if"
      // attribute is likely to contain an operator

      var prevQuery = names === undefined ? true : preventQuery;
      return prop === undefined ? undefined : this._fill(prop, prevQuery, customizer);
    }
  }, {
    key: "get",
    value: function get(names, preventQuery, customizer) {
      return this._getFilled(names, preventQuery, customizer);
    }
  }, {
    key: "_setFillerProps",
    value: function _setFillerProps(props) {
      // getFillerProps() wraps the props in a Getter so that the values can be retrieved dynamically,
      // allowing for things like retrieving data from deely nested components.
      this._fillerProps = this._componentFillerProps.getFillerProps(_objectSpread(_objectSpread({}, props), {}, {
        self: this
      }));
    }
  }, {
    key: "_setWhereProps",
    value: function _setWhereProps(where, props) {
      // getWhereProps() resolves all the properties in the query and populates _whereProps. This
      // allows us to dynamically query data in deeply nested components.
      this._whereProps = this._componentFillerProps.getWhereProps(where, _objectSpread(_objectSpread({}, props), {}, {
        self: this
      }));
    }
  }, {
    key: "run",
    value: function () {
      var _run = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(props) {
        var where, shouldRun, actions, filtered, args, i;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                this._setFillerProps(props);

                where = this.get('if', true);
                shouldRun = true;
                actions = null;

                if (where) {
                  this._setWhereProps(where, props);

                  filtered = (0, _query.filter)([this._whereProps], where);

                  if (filtered.length === 0) {
                    // Condition failed
                    if (this.get('else')) {
                      actions = this.get('else');
                    } else {
                      // The condition failed and there is nothing to execute
                      shouldRun = false;
                    }
                  } else {
                    // Condition met
                    actions = this.get('actions');
                  }
                } else {
                  actions = this.get('actions');
                }

                if (!shouldRun) {
                  _context.next = 21;
                  break;
                }

                if (!actions) {
                  _context.next = 20;
                  break;
                }

                args = null;
                _context.t0 = _regenerator.default.keys(actions);

              case 9:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 17;
                  break;
                }

                i = _context.t1.value;

                if (!args && props && props.arguments) {
                  args = props.arguments;
                }

                _context.next = 14;
                return actions[i].run(_objectSpread(_objectSpread({}, props), {}, {
                  arguments: args,
                  parent: this,
                  context: props && props.context
                }));

              case 14:
                args = _context.sent;
                _context.next = 9;
                break;

              case 17:
                return _context.abrupt("return", args);

              case 20:
                return _context.abrupt("return", this.act(props));

              case 21:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function run(_x) {
        return _run.apply(this, arguments);
      }

      return run;
    }()
  }]);
  return Action;
}(_component.default);

exports.default = Action;