"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _form = _interopRequireDefault(require("./form"));

var _formEditor = _interopRequireDefault(require("./form-editor"));

var _tabs = _interopRequireDefault(require("../tabs"));

var _formField = _interopRequireDefault(require("../fields/form-field"));

var _set = _interopRequireDefault(require("../actions/set"));

var _emit = _interopRequireDefault(require("../actions/emit"));

var _jsonStringify = _interopRequireDefault(require("../actions/json-stringify"));

var _text = _interopRequireDefault(require("../text"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FormBuilder = /*#__PURE__*/function (_Form) {
  (0, _inherits2.default)(FormBuilder, _Form);

  var _super = _createSuper(FormBuilder);

  function FormBuilder() {
    var _this;

    (0, _classCallCheck2.default)(this, FormBuilder);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "className", 'FormBuilder');
    return _this;
  }

  (0, _createClass2.default)(FormBuilder, [{
    key: "create",
    value: function create(props) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(FormBuilder.prototype), "create", this).call(this, props);
      this.set({
        schema: {
          component: 'Form',
          fields: [{
            // This name is needed so that we can make sure to relay the value to the backend or any
            // front-end component cache
            name: 'formName',
            component: 'TextField'
          }, {
            name: 'definition',
            component: 'Field'
          }]
        },
        fields: [new _tabs.default({
          name: 'tabs',
          items: [{
            name: 'edit',
            label: 'Edit',
            icon: 'Edit'
          }, {
            name: 'preview',
            label: 'Preview',
            icon: 'ViewCompact'
          }, {
            name: 'export',
            label: 'Export',
            icon: 'code'
          }]
        }), new _text.default({
          name: 'definition',
          hidden: true
        }), new _formField.default({
          name: 'form',
          form: new _formEditor.default()
        })],
        listeners: [{
          event: 'fields.tabs.content.edit',
          actions: [new _set.default({
            name: 'fields.form.form.editable',
            value: true
          }), new _emit.default({
            event: 'hideCode'
          })]
        }, {
          event: 'fields.tabs.content.preview',
          actions: [new _set.default({
            name: 'fields.form.form.editable',
            value: false
          }), new _emit.default({
            event: 'hideCode'
          })]
        }, {
          event: 'fields.tabs.content.export',
          actions: [new _jsonStringify.default({
            value: '{{definition}}',
            space: 2
          }), new _set.default({
            name: 'fields.definition.content.text',
            value: '```js\n{{arguments}}\n```\n'
          }), new _emit.default({
            event: 'setCodeHidden',
            value: {
              hideCode: false,
              hideForm: true
            }
          })]
        }, {
          event: 'setCodeHidden',
          actions: [new _set.default({
            name: 'fields.definition.content.hidden',
            value: '{{arguments.hideCode}}'
          }), new _set.default({
            name: 'fields.form.hidden',
            value: '{{arguments.hideForm}}'
          })]
        }, {
          event: 'hideCode',
          actions: [new _emit.default({
            event: 'setCodeHidden',
            value: {
              hideCode: true,
              hideForm: false
            }
          })]
        }]
      });
    }
  }, {
    key: "_setDefinition",
    value: function _setDefinition(definition) {
      var fields = definition.fields.map(function (field) {
        // Use componentName instead of component
        var value = _objectSpread(_objectSpread({}, field), {}, {
          componentName: field.component
        });

        delete value.component;
        return value;
      });
      this.get('fields.form.form.fields.fields').setValue(fields);
      this.set({
        formName: definition.name
      });
    }
  }, {
    key: "set",
    value: function set(props) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(FormBuilder.prototype), "set", this).call(this, _objectSpread(_objectSpread({}, props), {}, {
        definition: undefined
      }));

      if (props.definition !== undefined) {
        this._setDefinition(props.definition);
      } // We also allow the definition to be set via the value so that both the definition and other
      // values, like id & userId, can be set simultaneously


      if (props.value !== undefined && props.value.definition !== undefined) {
        this._setDefinition(props.value.definition);
      }
    }
  }, {
    key: "_getDefinition",
    value: function _getDefinition() {
      return {
        name: this.get('formName'),
        component: 'Form',
        fields: this.get('fields.form.form.fields.fields').mapForms(function (form) {
          return _objectSpread(_objectSpread({}, form.getValues({
            default: false
          })), {}, {
            component: form.getValue('componentName'),
            componentName: undefined
          });
        })
      };
    }
  }, {
    key: "getOne",
    value: function getOne(name) {
      if (name === 'definition') {
        return this._getDefinition();
      }

      return (0, _get2.default)((0, _getPrototypeOf2.default)(FormBuilder.prototype), "getOne", this).call(this, name);
    }
  }]);
  return FormBuilder;
}(_form.default);

exports.default = FormBuilder;