"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _form = _interopRequireDefault(require("./form"));

var _collectionField = _interopRequireDefault(require("../fields/collection-field"));

var _factory = _interopRequireDefault(require("../component/factory"));

var _fieldEditorForm = _interopRequireDefault(require("./field-editor-form"));

var _utils = _interopRequireDefault(require("../utils"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FormEditor = /*#__PURE__*/function (_Form) {
  (0, _inherits2.default)(FormEditor, _Form);

  var _super = _createSuper(FormEditor);

  function FormEditor() {
    var _this;

    (0, _classCallCheck2.default)(this, FormEditor);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "className", 'FormEditor');
    return _this;
  }

  (0, _createClass2.default)(FormEditor, [{
    key: "create",
    value: function create(props) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(FormEditor.prototype), "create", this).call(this, props);
      this.set({
        schema: {
          component: 'Form',
          fields: [{
            name: 'definition',
            component: 'Field'
          }]
        },
        fields: [new _collectionField.default({
          name: 'fields',
          label: 'Fields',
          hideLabel: true,
          maxColumns: 1,
          skipRead: true,
          includeExtraneous: true,
          forbidOrder: false,
          formFactory: new _factory.default({
            product: function product() {
              return new _fieldEditorForm.default({
                value: {
                  // Generate a unique id so that the UI has a key when displaying a list of items.
                  // We generate the id here as we don't want the rendering layer adding the ids.
                  id: _utils.default.uuid()
                },
                validators: [{
                  where: {
                    'parent.value': {
                      $elemMatch: {
                        id: {
                          $ne: '{{fields.id.value}}'
                        },
                        name: '{{fields.name.value}}'
                      }
                    }
                  },
                  error: {
                    field: 'name',
                    error: 'must be unique'
                  }
                }]
              });
            }
          })
        })]
      });
    }
  }, {
    key: "_setDefinition",
    value: function _setDefinition(definition) {
      var fields = definition.fields.map(function (field) {
        // Use componentName instead of component
        var value = _objectSpread(_objectSpread({}, field), {}, {
          componentName: field.component
        });

        delete value.component;
        return value;
      });
      this.get('fields.fields').setValue(fields);
    }
  }, {
    key: "set",
    value: function set(props) {
      (0, _get2.default)((0, _getPrototypeOf2.default)(FormEditor.prototype), "set", this).call(this, _objectSpread(_objectSpread({}, props), {}, {
        definition: undefined
      }));

      if (props.definition !== undefined) {
        this._setDefinition(props.definition);
      }
    }
  }, {
    key: "_getDefinition",
    value: function _getDefinition() {
      return {
        component: 'Form',
        fields: this.get('fields.fields').mapForms(function (form) {
          return _objectSpread(_objectSpread({}, form.getValues({
            default: false
          })), {}, {
            component: form.getValue('componentName'),
            componentName: undefined
          });
        })
      };
    }
  }, {
    key: "getOne",
    value: function getOne(name) {
      if (name === 'definition') {
        return this._getDefinition();
      }

      return (0, _get2.default)((0, _getPrototypeOf2.default)(FormEditor.prototype), "getOne", this).call(this, name);
    }
  }]);
  return FormEditor;
}(_form.default);

exports.default = FormEditor;